/* Copyright (C) 1996 Robert de Bath <rdebath@cix.compulink.co.uk>
 * This file is part of the Linux-8086 C library and is distributed
 * under the GNU Library General Public License.
 */

/*
 * Manuel Novoa III       Dec 2000
 *
 * Converted to use my new (un)signed long (long) to string routines, which
 * are smaller than the previous functions and don't require static buffers.
 */

#include <unistd.h>
#include <string.h>
#include <stdlib.h>

extern void PFprintf( const char * format, ... ); // %d %x %s, a-la printf

static void errput(const char *str)
{
	PFprintf( str );
}

void __assert(assertion, filename, linenumber, function)
const char *assertion;
const char *filename;
int linenumber;
const char *function;
{
	char buf[12];

	errput(filename);
	errput(":");
	errput(itoa(linenumber, buf , 10 ));
	errput(function ? ": " : "");
	errput(function ? function : "");
	errput(function ? "() " : "");
	errput(": Assertion \"");
	errput(assertion);
	errput("\" failed.\n");
	abort();
}
